Index: src/sas/qtgui/Utilities/UI/PluginDefinitionUI.ui
===================================================================
--- src/sas/qtgui/Utilities/UI/PluginDefinitionUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UI/PluginDefinitionUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,150 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>PluginDefinition</class>
+ <widget class="QWidget" name="PluginDefinition">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>723</width>
+    <height>784</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Plugin Definition</string>
+  </property>
+  <layout class="QGridLayout" name="gridLayout_7">
+   <item row="0" column="0">
+    <widget class="QGroupBox" name="groupBox_6">
+     <property name="title">
+      <string>Plugin name</string>
+     </property>
+     <layout class="QGridLayout" name="gridLayout_5">
+      <item row="0" column="0">
+       <widget class="QLineEdit" name="txtName">
+        <property name="placeholderText">
+         <string>Enter a plugin name</string>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="1">
+       <widget class="QCheckBox" name="chkOverwrite">
+        <property name="text">
+         <string>Overwrite existing plugin model of this name</string>
+        </property>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item row="1" column="0">
+    <widget class="QGroupBox" name="groupBox_5">
+     <property name="title">
+      <string>Description</string>
+     </property>
+     <layout class="QGridLayout" name="gridLayout_4">
+      <item row="0" column="0">
+       <widget class="QLineEdit" name="txtDescription">
+        <property name="placeholderText">
+         <string>Enter a description of the model</string>
+        </property>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item row="2" column="0">
+    <widget class="QGroupBox" name="groupBox">
+     <property name="title">
+      <string>Fit parameters</string>
+     </property>
+     <layout class="QGridLayout" name="gridLayout_3">
+      <item row="0" column="0">
+       <widget class="QGroupBox" name="groupBox_3">
+        <property name="title">
+         <string>Non-polydisperse</string>
+        </property>
+        <layout class="QGridLayout" name="gridLayout">
+         <item row="0" column="0">
+          <widget class="QTableWidget" name="tblParams">
+           <row>
+            <property name="text">
+             <string/>
+            </property>
+           </row>
+           <column>
+            <property name="text">
+             <string>Parameters</string>
+            </property>
+           </column>
+           <column>
+            <property name="text">
+             <string>Initial
+value</string>
+            </property>
+           </column>
+          </widget>
+         </item>
+        </layout>
+       </widget>
+      </item>
+      <item row="0" column="1">
+       <widget class="QGroupBox" name="groupBox_4">
+        <property name="title">
+         <string>Polydisperse</string>
+        </property>
+        <layout class="QGridLayout" name="gridLayout_2">
+         <item row="0" column="0">
+          <widget class="QTableWidget" name="tblParamsPD">
+           <row>
+            <property name="text">
+             <string/>
+            </property>
+           </row>
+           <column>
+            <property name="text">
+             <string>Parameters</string>
+            </property>
+           </column>
+           <column>
+            <property name="text">
+             <string>Initial
+value</string>
+            </property>
+           </column>
+          </widget>
+         </item>
+        </layout>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+   <item row="3" column="0">
+    <widget class="QGroupBox" name="groupBox_2">
+     <property name="title">
+      <string>Function(x)</string>
+     </property>
+     <layout class="QGridLayout" name="gridLayout_6">
+      <item row="0" column="0">
+       <widget class="QTextBrowser" name="txtFunction">
+        <property name="readOnly">
+         <bool>false</bool>
+        </property>
+        <property name="html">
+         <string>&lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0//EN&quot; &quot;http://www.w3.org/TR/REC-html40/strict.dtd&quot;&gt;
+&lt;html&gt;&lt;head&gt;&lt;meta name=&quot;qrichtext&quot; content=&quot;1&quot; /&gt;&lt;style type=&quot;text/css&quot;&gt;
+p, li { white-space: pre-wrap; }
+&lt;/style&gt;&lt;/head&gt;&lt;body style=&quot; font-family:'MS Shell Dlg 2'; font-size:7.8pt; font-weight:400; font-style:normal;&quot;&gt;
+&lt;p style=&quot;-qt-paragraph-type:empty; margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;&quot;&gt;&lt;br /&gt;&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+        </property>
+       </widget>
+      </item>
+     </layout>
+    </widget>
+   </item>
+  </layout>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
Index: src/sas/qtgui/Utilities/UI/PluginManagerUI.ui
===================================================================
--- src/sas/qtgui/Utilities/UI/PluginManagerUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UI/PluginManagerUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,113 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>PluginManagerUI</class>
+ <widget class="QDialog" name="PluginManagerUI">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>528</width>
+    <height>442</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Plugin Manager</string>
+  </property>
+  <layout class="QGridLayout" name="gridLayout">
+   <item row="0" column="0">
+    <widget class="QListWidget" name="lstModels">
+     <property name="contextMenuPolicy">
+      <enum>Qt::ActionsContextMenu</enum>
+     </property>
+     <property name="editTriggers">
+      <set>QAbstractItemView::NoEditTriggers</set>
+     </property>
+     <property name="selectionMode">
+      <enum>QAbstractItemView::ExtendedSelection</enum>
+     </property>
+     <property name="spacing">
+      <number>2</number>
+     </property>
+    </widget>
+   </item>
+   <item row="0" column="1">
+    <layout class="QVBoxLayout" name="verticalLayout">
+     <item>
+      <widget class="QPushButton" name="cmdAdd">
+       <property name="text">
+        <string>Add</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <widget class="QPushButton" name="cmdDuplicate">
+       <property name="text">
+        <string>Duplicate</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <widget class="QPushButton" name="cmdEdit">
+       <property name="text">
+        <string>Edit</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <widget class="QPushButton" name="cmdDelete">
+       <property name="text">
+        <string>Delete</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <spacer name="verticalSpacer">
+       <property name="orientation">
+        <enum>Qt::Vertical</enum>
+       </property>
+       <property name="sizeHint" stdset="0">
+        <size>
+         <width>20</width>
+         <height>40</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+    </layout>
+   </item>
+   <item row="1" column="0" colspan="2">
+    <layout class="QHBoxLayout" name="horizontalLayout">
+     <item>
+      <spacer name="horizontalSpacer">
+       <property name="orientation">
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="sizeHint" stdset="0">
+        <size>
+         <width>40</width>
+         <height>20</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+     <item>
+      <widget class="QPushButton" name="cmdHelp">
+       <property name="text">
+        <string>Help</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <widget class="QPushButton" name="cmdOK">
+       <property name="text">
+        <string>Close</string>
+       </property>
+      </widget>
+     </item>
+    </layout>
+   </item>
+  </layout>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
Index: src/sas/qtgui/Utilities/UI/TabbedModelEditor.ui
===================================================================
--- src/sas/qtgui/Utilities/UI/TabbedModelEditor.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UI/TabbedModelEditor.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,66 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>TabbedModelEditor</class>
+ <widget class="QDialog" name="TabbedModelEditor">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>688</width>
+    <height>697</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Model Editor</string>
+  </property>
+  <property name="windowIcon">
+   <iconset>
+    <normaloff>:/res/ball.ico</normaloff>:/res/ball.ico</iconset>
+  </property>
+  <layout class="QVBoxLayout" name="verticalLayout">
+   <item>
+    <widget class="QTabWidget" name="tabWidget">
+     <property name="currentIndex">
+      <number>-1</number>
+     </property>
+    </widget>
+   </item>
+   <item>
+    <layout class="QHBoxLayout" name="horizontalLayout">
+     <item>
+      <widget class="QPushButton" name="cmdLoad">
+       <property name="text">
+        <string>Load plugin...</string>
+       </property>
+      </widget>
+     </item>
+     <item>
+      <spacer name="horizontalSpacer">
+       <property name="orientation">
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="sizeHint" stdset="0">
+        <size>
+         <width>40</width>
+         <height>20</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+     <item>
+      <widget class="QDialogButtonBox" name="buttonBox">
+       <property name="orientation">
+        <enum>Qt::Horizontal</enum>
+       </property>
+       <property name="standardButtons">
+        <set>QDialogButtonBox::Apply|QDialogButtonBox::Cancel|QDialogButtonBox::Help</set>
+       </property>
+      </widget>
+     </item>
+    </layout>
+   </item>
+  </layout>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
Index: src/sas/qtgui/Utilities/UnitTesting/GridPanelTest.py
===================================================================
--- src/sas/qtgui/Utilities/UnitTesting/GridPanelTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UnitTesting/GridPanelTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,150 @@
+import sys
+import numpy as np
+import unittest
+from unittest.mock import mock_open, patch
+import webbrowser
+import logging
+
+from unittest.mock import MagicMock
+
+from PyQt5 import QtGui, QtWidgets
+
+# set up import paths
+import path_prepare
+
+from sas.qtgui.UnitTesting.TestUtils import QtSignalSpy
+
+from sas.sascalc.fit.AbstractFitEngine import FResult
+from sasmodels.sasview_model import load_standard_models
+from sas.qtgui.Plotting.PlotterData import Data1D
+
+import sas.qtgui.Utilities.GuiUtils as GuiUtils
+# Local
+from sas.qtgui.Utilities.GridPanel import BatchOutputPanel
+
+if not QtWidgets.QApplication.instance():
+    app = QtWidgets.QApplication(sys.argv)
+
+class BatchOutputPanelTest(unittest.TestCase):
+    '''Test the batch output dialog'''
+    def setUp(self):
+        '''Create the dialog'''
+        # dummy perspective
+        class dummy_manager(object):
+            def communicator(self):
+                return GuiUtils.Communicate()
+            def communicate(self):
+                return GuiUtils.Communicate()
+        self.widget = BatchOutputPanel(parent=dummy_manager(), output_data=self.output_for_test())
+        test_table = {"p1":[1,2,3],
+                      "p2":[4,5,None],
+                      "":["a",credits,],
+                      "":[]}
+
+    def tearDown(self):
+        '''Destroy the GUI'''
+        self.widget.close()
+        self.widget = None
+
+    def output_for_test(self):
+        ''' define DATA1D structure for testing'''
+        # dummy parameter set
+        m = None
+        for m in load_standard_models():
+            if m.name == "core_shell_ellipsoid":
+                model = m()
+        self.assertIsNotNone(m)
+        data = Data1D(x=[1,2], y=[3,4], dx=[0.1, 0.1], dy=[0.,0.])
+        param_list = ['sld_shell', 'sld_solvent']
+        output = FResult(model=model, data=data, param_list=param_list)
+        output.theory = np.array([0.1,0.2])
+        output.pvec = np.array([0.1, 0.02])
+        output.residuals = np.array([0.01, 0.02])
+        output.fitness = 9000.0
+        output.fitter_id = 200
+        output_data = [[output],[output]]
+        return output_data
+
+    def testDefaults(self):
+        '''Test the GUI in its default state'''
+        self.assertIsInstance(self.widget, QtWidgets.QMainWindow)
+        # Default title
+        self.assertEqual(self.widget.windowTitle(), "Grid Panel")
+
+        # non-modal window
+        self.assertFalse(self.widget.isModal())
+
+    def testActionLoadData(self):
+        '''Test CSV data loader'''
+        test_csv = mock_open(read_data = ("""\
+File generated by SasView\n
+Chi2,Data,scale,background,radius_equat_core,x_core,thick_shell,x_polar_shell,sld_core,sld_shell,sld_solvent,theta,phi,\n
+1917.8,cyl_400_40.txt,1,0.001,20,3,30,1,-85.088,-97.636,-92.797,0,0,\n
+2.6169,cyl_400_20.txt,1,0.001,20,3,30,1,914.64,906.09,905.67,0,0,\n
+"""))
+        logging.info = MagicMock()
+        self.widget.setupTableFromCSV = MagicMock()
+
+        # No filename given
+        QtWidgets.QFileDialog.getOpenFileName = MagicMock(return_value=[""])
+        self.widget.actionLoadData()
+        # Assure parser wasn't called and logging got a message
+        self.assertTrue(logging.info.called_once())
+        self.assertIn("No data", logging.info.call_args[0][0])
+
+        # Filename given
+        QtWidgets.QFileDialog.getOpenFileName = MagicMock(return_value="test")
+        with patch('builtins.open', test_csv):
+            self.widget.actionLoadData()
+            # Assure parser was called
+            self.assertTrue(self.widget.actionLoadData)
+            self.widget.setupTableFromCSV.assert_called_once()
+            self.assertIn("File generated by SasView", self.widget.setupTableFromCSV.call_args[0][0][0])
+
+    def notestPlotFits(self):
+        '''Test plot generation from selected table rows'''
+        # mock tested calls
+        #GuiUtils.Communicate.plot
+        spy_plot_signal = QtSignalSpy(self.widget.communicate, self.widget.communicate().plotFromFilenameSignal)
+        # Select row #1
+        self.widget.tblParams.selectRow(0)
+        QtWidgets.QApplication.processEvents()
+
+        # See that the signal was emitted
+        self.assertEqual(spy_plot_signal.count(), 1)
+        self.assertIn("ddd", str(spy_plot_signal.called()[0]['args'][0]))
+
+
+    def testDataFromTable(self):
+        '''Test dictionary generation from data'''
+        params = self.widget.dataFromTable(self.widget.tblParams)
+        self.assertEqual(len(params), 13)
+        self.assertEqual(params['Chi2'][0], '9000')
+        self.assertEqual(params['Data'][1], '')
+        self.assertEqual(params['sld_solvent'][1], '0.02')
+
+    def testActionSendToExcel(self):
+        '''Test Excel bindings'''
+        pass
+
+    def testActionSaveFile(self):
+        '''Test file save'''
+        self.widget.writeBatchToFile = MagicMock()
+
+        # user cancels dialog
+        QtWidgets.QFileDialog.getSaveFileName = MagicMock(return_value=("","BOOP"))
+        # write not called
+        self.widget.actionSaveFile()
+        self.widget.writeBatchToFile.assert_not_called()
+
+        # user chooses proper name
+        QtWidgets.QFileDialog.getSaveFileName = MagicMock(return_value=("plop","BOOP"))
+        # write called
+        self.widget.actionSaveFile()
+        self.widget.writeBatchToFile.assert_called_once()
+
+    def testSetupTableFromCSV(self):
+        '''Test generation of grid table rows from a CSV file'''
+        pass
+
+
Index: src/sas/qtgui/Utilities/UnitTesting/ModelEditorTest.py
===================================================================
--- src/sas/qtgui/Utilities/UnitTesting/ModelEditorTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UnitTesting/ModelEditorTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,51 @@
+import sys
+import unittest
+import logging
+
+from PyQt5.QtGui import *
+from PyQt5.QtCore import *
+from PyQt5.QtWidgets import *
+
+# set up import paths
+import sas.qtgui.path_prepare
+
+from UnitTesting.TestUtils import QtSignalSpy
+
+# Local
+from sas.qtgui.Utilities.ModelEditor import ModelEditor
+from sas.qtgui.Utilities.PythonSyntax import PythonHighlighter
+
+if not QApplication.instance():
+    app = QApplication(sys.argv)
+
+class ModelEditorTest(unittest.TestCase):
+    def setUp(self):
+        """
+        Prepare the editor
+        """
+        self.widget = ModelEditor(None)
+
+    def tearDown(self):
+        """Destroy the DataOperationUtility"""
+        self.widget.close()
+        self.widget = None
+
+    def testDefaults(self):
+        """Test the GUI in its default state"""
+        self.assertIsInstance(self.widget.highlight, PythonHighlighter)
+
+    def testEdit(self):
+        """Test that a signal is emitted on edit"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # Edit text
+        text = "test"
+        self.widget.txtEditor.setPlainText(text)
+
+        # Assure the signal got emitted
+        self.assertEqual(spy_signal.count(), 1)
+
+        # Assure getModel() returns right content
+        self.assertTrue(text, self.widget.txtEditor.toPlainText())
+
+
Index: src/sas/qtgui/Utilities/UnitTesting/PluginDefinitionTest.py
===================================================================
--- src/sas/qtgui/Utilities/UnitTesting/PluginDefinitionTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
+++ src/sas/qtgui/Utilities/UnitTesting/PluginDefinitionTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -0,0 +1,175 @@
+import sys
+import unittest
+import logging
+
+from PyQt5.QtGui import *
+from PyQt5.QtCore import *
+from PyQt5.QtWidgets import *
+
+# set up import paths
+import sas.qtgui.path_prepare
+
+from UnitTesting.TestUtils import QtSignalSpy
+
+# Local
+from sas.qtgui.Utilities.PluginDefinition import PluginDefinition
+from sas.qtgui.Utilities.PythonSyntax import PythonHighlighter
+
+#if not QApplication.instance():
+#    app = QApplication(sys.argv)
+app = QApplication(sys.argv)
+
+class PluginDefinitionTest(unittest.TestCase):
+    def setUp(self):
+        """
+        Prepare the editor
+        """
+        self.widget = PluginDefinition(None)
+
+    def tearDown(self):
+        """Destroy the DataOperationUtility"""
+        self.widget.close()
+        self.widget = None
+
+    def testDefaults(self):
+        """Test the GUI in its default state"""
+        self.assertIsInstance(self.widget.highlight, PythonHighlighter)
+        self.assertIsInstance(self.widget.parameter_dict, dict)
+        self.assertIsInstance(self.widget.pd_parameter_dict, dict)
+
+        self.assertEqual(len(self.widget.model), 6)
+        self.assertIn("filename", self.widget.model.keys())
+        self.assertIn("overwrite", self.widget.model.keys())
+        self.assertIn("description", self.widget.model.keys())
+        self.assertIn("parameters", self.widget.model.keys())
+        self.assertIn("pd_parameters", self.widget.model.keys())
+        self.assertIn("text", self.widget.model.keys())
+
+    def testOnOverwrite(self):
+        """See what happens when the overwrite checkbox is selected"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # check the default
+        self.assertFalse(self.widget.chkOverwrite.isChecked())
+
+        # Change the state
+        self.widget.chkOverwrite.setChecked(True)
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertTrue(self.widget.model['overwrite'])
+
+    def testOnPluginNameChanged(self):
+        """See what happens when the name of the plugin changes"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # Change the name
+        new_text = "Duck season"
+        self.widget.txtName.setText(new_text)
+        self.widget.txtName.editingFinished.emit()
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertTrue(self.widget.model['filename'] == new_text)
+
+    def testOnDescriptionChanged(self):
+        """See what happens when the description of the plugin changes"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # Change the name
+        new_text = "Rabbit season"
+        self.widget.txtDescription.setText(new_text)
+        self.widget.txtDescription.editingFinished.emit()
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertTrue(self.widget.model['description'] == new_text)
+
+    def testOnParamsChanged(self):
+        """See what happens when parameters change"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # number of rows. default=1
+        self.assertEqual(self.widget.tblParams.rowCount(), 1)
+
+        # number of columns. default=2
+        self.assertEqual(self.widget.tblParams.columnCount(), 2)
+
+        # Change the param
+        new_param = "shoot"
+        self.widget.tblParams.setItem(0,0,QTableWidgetItem(new_param))
+        #self.widget.tblParams.editingFinished.emit()
+
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertEqual(self.widget.model['parameters'], {0: (new_param, None)})
+
+        # Change the value
+        new_value = "BOOM"
+        self.widget.tblParams.setItem(0,1,QTableWidgetItem(new_value))
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 2)
+
+        # model dict updated
+        self.assertEqual(self.widget.model['parameters'], {0: (new_param, new_value)})
+
+        # See that the number of rows increased
+        self.assertEqual(self.widget.tblParams.rowCount(), 2)
+
+    def testOnPDParamsChanged(self):
+        """See what happens when pd parameters change"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # number of rows. default=1
+        self.assertEqual(self.widget.tblParamsPD.rowCount(), 1)
+
+        # number of columns. default=2
+        self.assertEqual(self.widget.tblParamsPD.columnCount(), 2)
+
+        # Change the param
+        new_param = "shoot"
+        self.widget.tblParamsPD.setItem(0,0,QTableWidgetItem(new_param))
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertEqual(self.widget.model['pd_parameters'], {0: (new_param, None)})
+
+        # Change the value
+        new_value = "BOOM"
+        self.widget.tblParamsPD.setItem(0,1,QTableWidgetItem(new_value))
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 2)
+
+        # model dict updated
+        self.assertTrue(self.widget.model['pd_parameters'] == {0: (new_param, new_value)})
+
+        # See that the number of rows increased
+        self.assertEqual(self.widget.tblParamsPD.rowCount(), 2)
+
+    def testOnFunctionChanged(self):
+        """See what happens when the model text changes"""
+        spy_signal = QtSignalSpy(self.widget, self.widget.modelModified)
+
+        # Change the text
+        new_model = "1\n2\n"
+        self.widget.txtFunction.setPlainText(new_model)
+
+        # Check the signal
+        self.assertEqual(spy_signal.count(), 1)
+
+        # model dict updated
+        self.assertEqual(self.widget.model['text'], new_model.rstrip())
+
